<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<ng-container *ngLet="error$ | async as error">
  <ng-container *ngLet="result$ | async as result">
    <ng-container *ngLet="(status$ | async) ?? 0 as status">
      <div class="w-full h-24 flex items-center gap-8 px-2 rounded-sm">
        <div class="size-12 bg-whitesmoke rounded-full flex items-center justify-center shrink-0">
          <i *ngIf="write" class="pi pi-upload text-skyBlue" style="font-size: 1rem"></i>
          <i *ngIf="read" class="pi pi-download text-grassGreen" style="font-size: 1rem"></i>
        </div>
        <div class="flex items-center gap-2 grow shrink-0 justify-between">
          <div class="flex flex-col gap-1">
            <div class="flex items-center justify-between gap-10">
              <div>
                <div class="font-semibold text-sm w-48 truncate">
                  <span class="text-primary-500">{{ consumption.item.title }}:</span
                  ><span class="text-secondary-900">{{ consumption.property.key }}</span>
                </div>
                <div *ngIf="consumption.item.organisation" class="text-text-300 text-sm flex items-center gap-1 pb-0.5">
                  <i class="fa fa-house-user" style="font-size: 0.8rem"></i>
                  <div>{{ consumption.item.organisation.name }}</div>
                </div>
              </div>
              <div class="text-text-300">{{ status }} %</div>
            </div>
            <div class="w-72">
              <p-progressBar
                [value]="status"
                [style]="{ height: '4px' }"
                [showValue]="false"
                [color]="error ? '#ff3a3a' : status >= 100 ? '#5bc566' : '#313131'"
              />
            </div>
          </div>
          <div *ngIf="!error" class="grow flex justify-center items-center pl-16">
            <p-tag *ngIf="read && status < 100" value="Downloading" severity="warning"></p-tag>
            <p-tag *ngIf="write && status < 100" value="Uploading" severity="warning"></p-tag>
            <p-tag *ngIf="read && status >= 100" value="Downloaded" severity="success"></p-tag>
            <p-tag *ngIf="write && status >= 100" value="Uploaded" severity="success"></p-tag>
          </div>
          <div *ngIf="error" class="grow flex justify-center items-center pl-16">
            <p-tag
              [value]="unauthorized(error) ? 'No Contract' : payloadTooLarge(error) ? 'Payload Too Large' : 'Failed'"
              severity="danger"
            ></p-tag>
          </div>
        </div>
        <div class="flex items-center justify-end w-40 shrink-0">
          <div *ngIf="!error" pTooltip="Download file" tooltipPosition="bottom">
            <p-button
              icon="pi pi-download"
              [text]="true"
              [rounded]="true"
              severity="secondary"
              [disabled]="status < 100 || !result"
              (onClick)="downloadBody(result!)"
            ></p-button>
          </div>
          <div *ngIf="error" pTooltip="Download error" tooltipPosition="bottom">
            <p-button
              icon="pi pi-download"
              [text]="true"
              [rounded]="true"
              severity="secondary"
              (onClick)="downloadError(error)"
            ></p-button>
          </div>
          <div *ngIf="error" pTooltip="View error" tooltipPosition="bottom">
            <p-button
              [text]="true"
              icon="fa fa-eye"
              [rounded]="true"
              severity="secondary"
              (onClick)="showError = true"
            ></p-button>
          </div>
          <div
            *ngIf="!error"
            [pTooltip]="isJsonOrText(result) ? 'View response' : 'Can not view response'"
            tooltipPosition="bottom"
          >
            <p-button
              icon="fa fa-eye"
              [text]="true"
              [rounded]="true"
              severity="secondary"
              [disabled]="status < 100 || !isJsonOrText(result)"
              (onClick)="showBody = true"
            ></p-button>
          </div>
          <p-button
            icon="pi pi-ellipsis-h"
            [text]="true"
            [rounded]="true"
            severity="secondary"
            [disabled]="!error && status < 100"
            (onClick)="menu.toggle($event)"
          ></p-button>
          <p-menu #menu [model]="options" [popup]="true" appendTo="body"> </p-menu>
        </div>
      </div>
    </ng-container>
  </ng-container>
</ng-container>
<p-sidebar [(visible)]="showBody" [fullScreen]="true" appendTo="body">
  <ng-template pTemplate="header">
    <div class="grow flex items-center gap-2">
      <i class="fa-solid fa-circle-check text-success" style="font-size: 1.2rem"></i>
      <div class="text-xl font-semibold">
        <span class="text-secondary-900"> {{ consumption.item.title }}:</span
        ><span class="text-primary-500"> {{ consumption.property.key }}</span>
      </div>
    </div>
  </ng-template>
  <ng-template pTemplate="content">
    <app-code-editor [(ngModel)]="body" [readOnly]="true"></app-code-editor>
  </ng-template>
</p-sidebar>
<p-sidebar [(visible)]="showError" [fullScreen]="true" appendTo="body">
  <ng-template pTemplate="header">
    <div class="grow flex items-center gap-2">
      <i class="fa-solid fa-circle-exclamation text-danger" style="font-size: 1.4rem"></i>
      <div class="text-xl font-semibold">
        <span class="text-secondary-900"> {{ consumption.item.title }}:</span
        ><span class="text-primary-500"> {{ consumption.property.key }}</span>
      </div>
    </div>
  </ng-template>
  <ng-template pTemplate="content">
    <app-code-editor [(ngModel)]="error" [readOnly]="true"></app-code-editor>
  </ng-template>
</p-sidebar>
<p-sidebar [(visible)]="showCurl" [fullScreen]="true" appendTo="body">
  <ng-template pTemplate="header">
    <div class="grow flex items-center gap-2">
      <i class="fa-solid fa-code text-secondary-900" style="font-size: 1.2rem"></i>
      <div class="text-xl font-semibold">
        <span class="text-secondary-900"> {{ consumption.item.title }}:</span
        ><span class="text-primary-500"> {{ consumption.property.key }}</span>
      </div>
    </div>
  </ng-template>
  <ng-template pTemplate="content">
    <div class="w-full h-full flex flex-col">
      <div class="shrink-0">
        <p-messages severity="info">
          <ng-template pTemplate>
            <i class="pi pi-info-circle"></i>
            <div class="ml-2 font-semibold">Credentials:</div>
            <div class="ml-2">Please include credentials in the Authorization header.</div>
            <p-button label="Generate new credentials" [link]="true" (onClick)="openCredentials()"></p-button>
          </ng-template>
        </p-messages>
      </div>
      <div class="w-full grow">
        <app-code-editor [(ngModel)]="curl" mode="sh" [readOnly]="true" [allowCopy]="true"></app-code-editor>
      </div>
    </div>
  </ng-template>
</p-sidebar>
